
Coroutine do(
	type := "Coroutine"
	newSlot("exception", nil)
	newSlot("parentCoroutine", nil)
	newSlot("runTarget", nil)
	newSlot("runLocals", nil)
	newSlot("runMessage", nil)
	newSlot("result", nil)
	newSlot("label", nil)
	label := method("")
	
	typeId := method(self type .. "_0x" .. self uniqueId asString toBase(16) .. " " .. self label)

	callStack := method(
		ioStack select(v, Object argIsActivationContext(getSlot("v"))) reverse
	)

	ActivationContext description := method(
		m := self message
		s := self target type .. " " .. m name
		s .. " " repeated(s size - 35) .. m label lastPathComponent .. " line " .. m lineNumber	
	)
	
	Message description := method(
		self name .. " " repeated(self name size - 35) .. self label lastPathComponent .. " line " .. self lineNumber	
	)
	
	backTraceString := method(
		buf := Sequence clone

		if(exception, 
			buf appendSeq("\nException: ", exception error, "\n\n")
		)
		
		buf appendSeq("  ", self typeId)
		
		if(callStack size > 0) then(
			buf appendSeq("\n  -------------------\n")
			
			if(exception and exception caughtMessage, 
				buf appendSeq("  ", exception caughtMessage description, "\n")
			)
			
			callStack foreach(v, buf appendSeq("  ", v description, "\n"))
			buf appendSeq("\n")
		) else(buf appendSeq(" empty\n"))

		//if (parentCoroutine, buf appendSeq(parentCoroutine backTraceString))
		buf
	)
	
	showStack := method(write(backTraceString))

	resumeParentCoroutine := method(
		//writeln(self typeId, " resumeParentCoroutine ", parentCoroutine typeId)
		if(parentCoroutine,
			parentCoroutine resume
			parentCoroutine scheduleNext
		)
		self pause
	)

	main := method(
		setResult(runTarget doMessage(runMessage, runLocals))
		resumeParentCoroutine
		self pause
	)

	raiseException := method(e, 
		self setException(e)
		resumeParentCoroutine
	)
	
	//resume := method(coroutine resume)
)

Message do(
	codeOfLength := method(length,
		c := self code
		if (c size < length, c, c slice(0, length) .. "...") asMutable replaceSeq("\n", ";")
	)

	asStackEntry := method(
		label := label lastPathComponent fileName
		label .. " " repeated(label size - 18) .. lineNumber .. " " repeated(lineNumber asString size - 6)  .. name
	)
)

Object try := method(
	//writeln("try(", call message argAt(0) code, ") ----------------------")
	currentCoro := Scheduler currentCoroutine
	coro := Coroutine clone
	coro setParentCoroutine(currentCoro) 
	coro setRunTarget(call sender) 
	coro setRunLocals(call sender)
	coro setRunMessage(call message argAt(0)) 
	coro run
	coro scheduleNext
	currentCoro pause
	if(coro exception, coro exception, nil)
)

Object coroDo := method(
	currentCoro := Scheduler currentCoroutine
	coro := Coroutine clone
	coro setRunTarget(self) 
	coro setRunLocals(call sender)
	coro setRunMessage(call message argAt(0)) 
	coro run
	coro scheduleNext
	coro
)

nil do(
	catch := nil
	pass := nil
)

Protos Exception do(
	type := "Exception"
	newSlot("error", nil)
	newSlot("coroutine", nil)
	newSlot("caughtMessage", nil)
	
	raise := method(error,
		currentCoro := Scheduler currentCoroutine
		e := self clone setError(error) setCoroutine(currentCoro)
		currentCoro raiseException(e)
	)
	
	catch := method(exceptionProto,
		if (self isKindOf(exceptionProto),
			call sender doMessage(call message argAt(1))
		)
		self
	)

	pass := method(
		Scheduler currentCoroutine raiseException(self)
	) 

	showStack := method(coroutine showStack)
)
