
Protos CLI := Object clone do(
	type := "CLI"
	stdout := File clone standardOutput
	stdin  := File clone standardInput
	inPrompt  := "Io> "
	outPrompt := "==> "
	multiLine := true
	newSlot("evalContext", method(Lobby))
	newSlot("isRunning", true)
	
	stop := method(setIsRunning(false))
	
	runPath := method(path,
		//Lobby launchPath := Directory currentWorkingDirectory asMutable appendPathSeq(path pathComponent)
		Lobby launchPath := path pathComponent

		result := 0
		e := try(result = Lobby doFile(path))
		if(e, e showStack)
		if(getSlot("result") type != "Number", result = 0)
		System exit(result)
	)

	run := method(
		Lobby launchPath := Directory currentWorkingDirectory
        Lobby exit := method(System exit)
        
		if(?args and(args size > 0), 
			args foreach(i, arg,
			
				if(arg == "-e", 
					writeln(evalContext doString(args slice(i + 1) join(" ")))
					return
				)
				
				if(arg == "-i",
					nextArg := args at(i + 1) 
					if(nextArg, runPath(nextArg))
					return interactiveMultiline
				)
				
				runPath(arg)
			)
		)

        interactiveMultiline
	)
	
	interactive := method(
 		writeln(System distribution, " ", System version)
 		while(isRunning,
			write(inPrompt)
			line := stdin readLine
			line ifNil(Lobby exit)
			result := nil
			e := try(result = evalContext doString(line))
			if(e, e showStack)
			writeln(outPrompt, getSlot("result"))
		)
	)
	
	interactiveMultiline := method(
		writeln(System distribution, " ", System version)
		errTriQuote := try(Compiler messageForString("\"\"\"")) error
		errParen    := try(Compiler messageForString("(")) error
		errArg      := try(Compiler messageForString("(x,")) error
		listContinueOnErr := list(errTriQuote, errParen)

  		while(isRunning,
  			write(inPrompt)
			line := ""
			loop(
				nextLine := stdin readLine
				nextLine ifNil(Lobby exit)
				line := line .. "\n" .. (nextLine)
				if(line endsWithSeq("\\"), continue)
				result := nil
				e := try(result = evalContext doString(line))
				if(e,
					err := e error
					if(self multiLine and(
						  listContinueOnErr contains(err) or(
						  err ==(errArg) and(line asMutable strip endsWithSeq(",")) ) 
						  ),
						continue
					)
					e showStack
				)
				break
			)
			writeln("\n", outPrompt, getSlot("result"))
		)
	)
)

/*
Shell := Object clone do(
	newSlot("folder", Directory clone)
	
	doString := method(s,
		if(s size == 1, show, super(doString(s)))
	)
	
	show := method(
		folder items foreach(item, item name println)
	)
	
	forward := method(
		writeln("forwarding ", call message name)
		item := folder at(call message name)
		item ifNil(writeln("no such file"); return)
		if(item type == "Directory", setFolder(item); show; return)
		if(item isUserExecutable) then(
			System system(item path)
		) else(
			System system("open " .. item path)
		)
	)
)

CLI setEvalContext(Shell)
*/
