Importer := Object clone do(
    docDescription("A simple search path based auto-importer.")

    paths := List clone append("")
    debug := nil
    addSearchPath := method(p, paths append(p))
    extensions := list("io")

    executeString := method(name, s,
		Lobby doString(s, name)
		r := Lobby getSlot(name)
		if(r, return r)
		Exception raise("Importer slot '" .. name .. "' missing after file load")
		nil    
    )
    
	execute_io := method(path, name, extension,
		p := Path with(path, name .. "." .. extension)
		s := File clone setPath(p) asBuffer
		executeString(name, s)
	)

	find := method(name, theObject,
		p := ?launchPath
		if(p and(paths contains(p) not), paths atInsert(0, p))  
		if(name at(0) isUpperCase, paths foreach(p, 
			extensions foreach(extension,
				fullPath := Path with(p, name .. "." .. extension)
				if(debug, write("Importer search:", p, "\n"))
				if(File clone setPath(fullPath) exists, 
					r := self perform("execute_" .. extension, p, name, extension)
					if (r, return r)
				)
				)
			)
		)
		Exception raise("Importer " .. theObject type .. " does not respond to '" .. name .. "'")
    )

    docSlot("turnOn", "Turns on the Importer. Returns self.")    
    turnOn := method(Lobby forward := method(Importer find(call message name, self)); self)

    docSlot("turnOff", "Turns off the Importer. Returns self.")    
    turnOff := method(Lobby removeSlot("forward"); self)
    turnOn
)

