// Test Benchmark
Sequence do(
    alignLeftInPlace := method(width, padding,
        padding = padding ifNil(" ")
        ((width - size) / padding size) ceil repeatTimes(appendSeq(padding))
        setSize(width)
    )
    alignLeft := method(width, padding,
      asMutable alignLeftInPlace(width, padding)
    )
    alignRight := method(width, padding,
        Sequence clone alignLeftInPlace(width - size, padding, Sequence clone) appendSeq(self)
    )
    alignCenter := method(width, padding,
        alignRight(((size + width) / 2) floor, padding) alignLeftInPlace(width, padding)
    )
)

Timer := Object clone do(
  runningTime := Nil

  start := method(self t1 := Date clone now; self)
  end := method(runningTime = Date clone now secondsSince(t1); self)
)

Benchmark := Object clone do(
  benchmark := method(cap,
    write(cap alignRight(30) .. " : ")
    t := Timer clone start
    sender doMessage(thisMessage argAt(1))
    t end runningTime println
  )
)

//test := method(
	writeln("test start")
	fib := method(n, if(n < 2, 1, fib(n - 2) + fib(n - 1)))
	ack := method(m, n, if(m < 1, return n + 1); if(n < 1, return ack(m - 1, 1)); return ack(m - 1, ack(m, n - 1)))
	benchmarks := Map clone atPut("Fibonacci (30)", "fib(30)")
	benchmarks atPut("Ackerman (3,5)", "ack(3, 5)")
	5 repeatTimes(benchmarks foreach(k, v, Benchmark clone benchmark(k, doString(v))))
	writeln("test end")
//)

//test